.proc BananaAI

ACTORCLASS      = DEFAULT_ACTOR
actorAngle      = actorData0
    
    ldy actorMapPos,x
    jsr SetMapPos
    mb { actorFlagsZP := actorFlagsZP|#1 }
    ACTOR_SET_PALETTE #2
    ACTOR_SET_PRIORITY 1
    ACTOR_SET_ANIMATION #ANIMATION_BANANA
    WAIT_UNTIL_ANIMATION_DONE

    jsr CheckForHit
    ;YIELD
    ;jmp Idle
    KILL_SELF

CheckForHit:
    ; Find Monkey
    ldy #MAX_ACTORS-1
findMonkeyLoop:
    lda actorType,y
    cmp #ACTOR_TYPE_MONKEY
    if equal
        jsr CheckCollision
        if equal
            ; Make monkey happy
            lda #1
            sta actorData1,y
        fi
    fi
    dey
    bpl findMonkeyLoop
    rts

CheckCollision:
    distX = TEMP+0
    distY = TEMP+1
    mb { distX := actorLoX[y] - actorLoX[x] }
    if negative
        eor #$FF
        clc
        adc #1
        sta distX
    fi
    mb { distY := actorLoY[y] - actorLoY[x] }
    if negative
        eor #$FF
        clc
        adc #1
        sta distY
    fi
    if (distX < #24) && (distY < #24)
        lda #0
        rts
    fi
    lda #1
    rts

.endproc
