.proc MonkeyAI

ACTORCLASS      = DEFAULT_ACTOR
actorAngle      = actorData0
    
    ldy actorMapPos,x
    jsr SetMapPos
    mb { actorFlagsZP := actorFlagsZP|#1 }
    ACTOR_SET_PALETTE #0
    ACTOR_SET_PRIORITY 1
    ACTOR_SET_ANIMATION #ANIMATION_MONKEY_SWINGING
    lda #0
    sta actorData1,x
Idle:
    lda actorData1,x
    if not zero
        jmp MonkeyHappy
    fi
    jsr UpdatePos
    YIELD
    jmp Idle
    
MonkeyHappy:
    MSG_BYTE "H",#0
    jsr RemoveCrosshair
    ACTOR_SET_ANIMATION #ANIMATION_MONKEY_HAPPY
IdleHappy:
    YIELD
    YIELD
    YIELD
    YIELD
    YIELD
    YIELD
    YIELD
    YIELD
    YIELD
    mb { actorFlagsZP := actorFlagsZP^#$40 }
    jmp IdleHappy

RemoveCrosshair:
    ldy #MAX_ACTORS-1
removeCrosshairLoop:
    if { actorType,y = #ACTOR_TYPE_CROSSHAIR }
        mb { actorAddrHi,y := #0 }
    fi
    dey
    bpl removeCrosshairLoop
    ; Spawn thank you message
    txa
    pha
    lda #ACTOR_TYPE_THANKYOU
    ldy #$46
    jsr AddActor
    pla
    tax
    rts
    
UpdatePos:
    lda actorAngle,x
    and #$7F
    tay
    lda MONKEY_SWING_X,y
    clc
    adc #126
    sta actorLoX,x
    lda MONKEY_SWING_Y,y
    clc
    adc #30
    sta actorLoY,x
    inc actorAngle,x
    lda actorAngle,x
    and #$7F
    sta TEMP
    MSG_BYTE "S",TEMP
    rts
    
.include "monkey_swing_coordinates.inc"
.endproc
