#! /usr/bin/env python 

import sys,os
import array
from PIL import Image
import imp
import string

#sprite = imp.load_source('sprite', sys.path[0] + '/../sprite.py')
#from sprite import *

#convertSpritesNES = imp.load_source('convertSpritesNES', '/home/michel/tilificator/trunk/convertSpritesNES.py')
sys.path.append('/home/michel/tilificator/trunk')
from convertSpritesNES import *

def tilifyImages(path, filename):
    tileSettings = TileSettings()
    tileSettings.colorSize = 4
    OptimizationSettings.tilingMethod = 'ShiftedRows'
    tileTable = TileTable(tileSettings)
    spriteImages = []
    for imageFilename in sorted([s for s in os.listdir(path) if s.endswith('.png')]):
        print "tilifying image '%s'" % imageFilename  
        si = SpriteImage(path + '/' + imageFilename)
        for progress in tilifySpriteImage(si, tileTable):
            pass #sys.stdout.write('.')
        spriteImages.append(si)
    # Write .chr file
    writeTiles(filename+'.chr', tileTable.data, tileTable.numTiles, RawFormats['NES'])
    # Write .tpr file
    tpr = TilificatorProject(tileTable)
    tpr.optimizationSettings = OptimizationSettings
    tpr.spriteImages = spriteImages
    tpr.palette = spriteImages[-1].palette
    with open(filename+'.tpr', 'w') as f:
        tpr.write(f)
    return len(spriteImages)

#
# Run as stand-alone program
#        
if __name__ == "__main__":
    print "test"
    os.system('rm uniqueimages_0/*')
    os.system('rm uniqueimages_1/*')
    os.system('rm uniqueimages_2/*')
    os.system('rm uniqueimages_3/*')
    os.system('python ../convertSpriteAnimations.py foo > animations.inc')
    numImagesBank0 = tilifyImages('uniqueimages_0','dragon')
    os.system('echo "NUM_IMAGES_BANK0 = %d\n" >> animations.inc' % (numImagesBank0+1))
    os.system('python /home/michel/tilificator/trunk/convertSpritesNES.py dragon.tpr > dragon.spr')
