.IFNDEF __MAP_H__
__MAP_H__ = 1
.SETCPU "6502X"
;.include "blocktypes.h"
.GLOBALZP BLOCK_BEEN_VISITED,BLOCK_STATIONARY,BLOCK_CONNECTED_LEFT,BLOCK_CONNECTED_RIGHT,BLOCK_CONNECTED_UP,BLOCK_CONNECTED_DOWN,BLOCK_CONNECTED_ALL
.GLOBALZP ENVIRONMENT_UPDATED, ENVIRONMENT_WATER

envMap                  = $6000
blockMapType            = $6100
blockMapFlags           = $6200
blockMapIndex           = $6300

.GLOBAL DrawMap
.GLOBAL WriteEntireMapToPPU
.GLOBAL ResetBlockFlags
.GLOBAL ResetEnvUpdatedFlag
.GLOBAL ResetBeenVisitedFlags

.GLOBALZP   bgMapPtr
.GLOBALZP   bobbingDelta
.GLOBALZP   fallingDelta
.GLOBALZP   waterCountdown,waterCountdownNEG,zeroDelta
.GLOBAL     CalculateDeltas,ChangeBlockTypeSub,ChangeBlockTypeSubY
.GLOBAL     FindSpriteBlocks,DrawSpriteBlocks
.ENDIF ; __MAP_H__
