#! /usr/bin/env python

import sys,os
import array
from PIL import Image
import imp
import string

#
# Run as stand-alone program
#        
if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "Usage: chrtorhc.py <file.chr> <file.rhc>"
        sys.exit(2)

    with open(sys.argv[1], 'rb') as infile:
        chrData = array.array('B', [])
        chrData.fromfile(infile, os.path.getsize(sys.argv[1]))
        rhcData = array.array('B', [0]*16*256)
        numTiles = len(chrData)/16
        for i in range(numTiles):
            for j in range(16):
                rhcData[256*j+i] = chrData[16*i+j]
        with open(sys.argv[2], 'wb') as outfile:
            rhcData.tofile(outfile)
