#!/bin/bash

ca65 --create-dep actor.d -t nes -g --debug-info -v -o actor.o actor.asm
ca65 --create-dep common.d -t nes -g --debug-info -v -o common.o common.asm
ca65 --create-dep gfx.d -t nes -g --debug-info -v -o gfx.o gfx.asm
ca65 --create-dep input.d -t nes -g --debug-info -v -o input.o input.asm
ca65 --create-dep map.d -t nes -g --debug-info -v -o map.o map.asm
ca65 --create-dep mapper.d -t nes -g --debug-info -v -o mapper.o mapper.asm
ca65 --create-dep level.d -t nes -g --debug-info -v -o level.o level.asm
ca65 --create-dep maploader.d -t nes -g --debug-info -v -o maploader.o maploader.asm
ca65 --create-dep main.d -t nes -g --debug-info -v -o main.o main.asm
ca65 --create-dep soundcode.d -t nes -g --debug-info -v -o soundcode.o soundcode.asm
ca65 --create-dep serial.d -t nes -g --debug-info -v -o serial.o serial.asm
cl65 -t nes -C main.cfg -v -m main.map -Wl --dbgfile,rnb.dbg ./actor.o ./common.o ./gfx.o ./input.o ./map.o ./mapper.o ./level.o ./maploader.o ./main.o ./soundcode.o ./serial.o -o main.nes

