.proc CrosshairAI

ACTORCLASS      = DEFAULT_ACTOR
actorAngle      = actorData0
    
    ldy actorMapPos,x
    jsr SetMapPos
    mb { actorFlagsZP := actorFlagsZP|#1 }
    ACTOR_SET_PALETTE #1
    ACTOR_SET_PRIORITY 0
    ACTOR_SET_ANIMATION #ANIMATION_CROSSHAIR
Idle:
    ;jsr UpdatePos
    jsr CheckForShot
    YIELD
    jmp Idle

CheckForShot:
    lda zapperP0
    tst #ZAPPER_TRIGGER
    if not zero
        jsr SpawnBanana
    fi
    rts

SpawnBanana:
    txa
    pha
    ; Save crosshair coordinates
    lda actorLoX,x
    pha
    lda actorLoY,x
    pha
    ;
    jsr GetMapPos
    tay
    lda #ACTOR_TYPE_BANANA
    jsr AddActor
    ; Assign crosshair coordinates to banana
    pla
    sta actorLoY,x
    pla
    sta actorLoX,x
    ;
    pla
    tax
    MSG_BYTE "B",#'B'
    rts

.endproc
