#! /usr/bin/env python 

import sys,os
import array
from PIL import Image
import imp
import string
from math import *

NUM_ANGLE_STEPS = 128

NUM_DEGREES    = 256

SCALE_X = 100.0
SCALE_Y = 127.0

IDLE_ANGLE = float(-NUM_DEGREES/4)
MAX_DELTA_ANGLE = float(NUM_DEGREES/4*0.7)

#
# Run as stand-alone program
#        
if __name__ == "__main__":
    xlist = []
    ylist = []
    for i in range(NUM_ANGLE_STEPS):
        angle = (-pi/2)+(pi/3)*sin((float(i)/float(NUM_ANGLE_STEPS))*2*pi)
        #angle = float(NUM_ANGLE_STEPS)*float(NUM_DEGREES)/pi
        print angle
        x,y = SCALE_X*cos(angle),-SCALE_Y*sin(angle)
        xlist.append('<'+str(int(x)))
        ylist.append('<'+str(int(y)))

    with open('monkey_swing_coordinates.inc', 'w') as f:
        f.write('MONKEY_SWING_X: .byte ' + ','.join(xlist) + '\n')
        f.write('MONKEY_SWING_Y: .byte ' + ','.join(ylist) + '\n')
8
