.IFNDEF __GFX_H__
__GFX_H__ = 1
.SETCPU "6502X"

.GLOBAL     drawList
.GLOBALZP   drawListPosW
.GLOBALZP   currentSpritePtr
.GLOBAL     ClearVRAM, UploadCHR, UploadSpriteCHR, SetPalette, ProcessDrawList, ClearDrawList
.GLOBAL     spritePage, DrawSpriteImage, DrawSpriteImageNoClipping, HideUnusedSprites, DrawAnimation
.GLOBALZP   attributeRowUpdated,paletteShadow
.GLOBALZP   attributeShadow
.GLOBAL     WriteAttributeShadow,ClearAttributeRowUpdated
.GLOBAL     WriteGraphicsBank
.GLOBAL     UploadTiles
.GLOBAL     ActorAddrMask,ActorAddrMaskFlip
.GLOBAL     SpriteImageAddrTabLo,SpriteImageAddrTabHi
.MACRO WRITE_PALETTE_SHADOW
    lda #$3F
    sta $2006
    lda #$00
    sta $2006
    ldx paletteShadow
.repeat 8,i
    stx $2007
    lda paletteShadow+1+3*i+0
    sta $2007
    lda paletteShadow+1+3*i+1
    sta $2007
    lda paletteShadow+1+3*i+2
    sta $2007
.endrep
.ENDMACRO

.ENDIF ; __GFX_H__

