.SETCPU "6502X"

.include "common.h"

.include "level.h"
.include "map.h"

.CODE
.include "levels/jungle/leveldata_jungle.inc"
.EXPORT bgMap_jungle_0_0
.SEGMENT "LEVELDATA"
LevelTileData:
.res 64
.INCBIN "levels/jungle/jungle.chr" ;"levels/jungle/jungle_remapped.chr"
LevelTileDataEnd:

LevelNumTiles4x = 16+4
LevelNumTiles1x = 255

;.CODE

NUM_BLOCKS = 29+1
   
WriteTile:
    @ChrPtr     = TEMP
    tya
    pha
    ldx #2
@TileLoop:
    ldy #0
:
    lda (@ChrPtr),y
    sta $2007
    iny
    cpy #8
    bne :-
    lda @ChrPtr
    clc
    adc #8
    sta @ChrPtr
    lda @ChrPtr+1
    adc #0
    sta @ChrPtr+1
    dex
    bne @TileLoop
    pla
    tay
    rts
 
    
    
LoadLevel:
    ldy #0
@1xTilesLoop:
    jsr WriteTile
    iny
    cpy #LevelNumTiles1x
    bne @1xTilesLoop
    rts
